/* 
 FSR test
 */

// minimum reading of the sensors that generates a note   
const int THRESHOLD = 25;    

int pinA0 = 0; 
int pinA1 = 1;  
int pinA2 = 2;  
int pinA3 = 3;  

static const int avgCount = 4;

int valFSR1, valFSR2, valFSR3, valFSR4 = 0; 

int arr1[avgCount];
int arr2[avgCount];
int arr3[avgCount];
int arr4[avgCount];

int i;
int index = 0;

//Average the values in the averaging arrays

void avg()
{
  valFSR1 = valFSR2 = valFSR3 = valFSR4 = 0;
  
  for(i = 0; i < avgCount; i++)
  {
    valFSR1 += arr1[i];
    valFSR2 += arr2[i];
    valFSR3 += arr3[i];
    valFSR4 += arr4[i];
  }
  
  valFSR1 /= avgCount;
  valFSR2 /= avgCount;
  valFSR3 /= avgCount;
  valFSR4 /= avgCount;
}

void setup() {
  // reset average arrays
  for (i = 0; i < avgCount; i++)
  {
    arr1[i] = 0;
    arr2[i] = 0;
    arr3[i] = 0;
    arr4[i] = 0;
  }
  index = 0;
   // start serial port at 9600 bps:
  Serial.begin(9600);
}

void loop() {
  
    // out actual values into the averaging arrays
    arr1[index] = analogRead(pinA0);
    arr2[index] = analogRead(pinA1);
    arr3[index] = analogRead(pinA2);
    arr4[index] = analogRead(pinA3);

    
    // increment index,
    // if index exceeds array sizes reset to zero
     index++;
     if (index >= avgCount)
     {
       index = 0;
     }
     
    // calculate average values
    avg();
    
    // divided the value by 4 to scale it down to 0 - 255
    // FSR 1  
    if((valFSR1 / 4) > THRESHOLD) {
      //Serial.print(valFSR1 / 4, DEC); Serial.print(", ");
      Serial.write('1');
    }

    // FSR 2        
    else if((valFSR2 / 4) > THRESHOLD) {
      //Serial.print(valFSR2 / 4 , DEC); Serial.print(", "); 
      Serial.write('2');
    }
    
    // FSR 3
    else if((valFSR3 / 4) > THRESHOLD) {    
      //Serial.print(valFSR3 / 4, DEC); Serial.print(", "); 
      Serial.write('3'); 
    }     
    
    // FSR 4   
    else if((valFSR4 / 4) > THRESHOLD) {  
      //Serial.print(valFSR4 /4 , DEC); Serial.println(); 
      Serial.write('4'); 
    }
    else {
      Serial.write('0');    
    }
   delay(100); 
}
