import processing.serial.*;

import ddf.minim.*;
import ddf.minim.signals.*;
import ddf.minim.analysis.*;
import ddf.minim.effects.*;

Serial XBeePort;
int val;

Minim minim;

//AudioSnippet kick;
//AudioSnippet BigDrum;
//AudioSnippet Cowbell;
//AudioSnippet Cymbals;
//AudioSnippet Snare;
AudioSample kick;
AudioSample BigDrum;
AudioSample Cowbell;
AudioSample Cymbals;
AudioSample Snare;


void setup() {
  size(200, 200, P2D);
  
  minim = new Minim(this);
  
  // Audio samples
  kick = minim.loadSample("kick.wav");
  BigDrum = minim.loadSample("BigDrum.wav");
  Cowbell = minim.loadSample("Cowbell.wav");
  Cymbals = minim.loadSample("Cymbals.wav");
  Snare = minim.loadSample("Snare.wav");
  
  //String XBeePort = Serial.list()[0];
  //XBeePort = new Serial(this, XBeePort, 9600);
  XBeePort = new Serial(this, "COM7", 9600);
  

}

void draw() {
  if(XBeePort.available() > 0) {
    val = XBeePort.read();
    //println((char)val);
    delay(1);
  }
  
  background(255);
  fill(0);

  ellipse(50, 50, 40, 40);   // 2
  ellipse(150, 50, 40, 40);  // 1
  ellipse(50, 150, 40, 40);  // 4
  ellipse(150, 150, 40, 40); // 3
  
  int grow; // = 50;
  
  switch(val) {
    case '1':
      fill(204);
      ellipse(150, 50, 40, 40);  // 2
      //delay(1);
     
      fill(255,0,0);
      for (grow = 40; grow < 90; grow++) {
        ellipse(150, 50, grow, grow);
      }
      //BigDrum.trigger();
      drumTrigger(1);
      break;
    case '2':
      fill(204);
      ellipse(50, 50, 40, 40);  // 1
      //delay(1);
    
      fill(0,255, 0);
      for (grow = 40; grow < 90; grow += 2) {
        ellipse(50, 50, grow, grow);
      }
      //Cowbell.trigger();
      drumTrigger(2);
      break;
    case '3':
      //Cymbals.trigger();
      drumTrigger(3);
      fill(204);
      ellipse(150, 150, 40, 40); // 4
      //delay(10);
      
      fill(0, 0, 255);
      for (grow = 40; grow < 90; grow += 2) {
        ellipse(150, 150, grow, grow);
      }
      break;
    case '4':
      fill(204);
      ellipse(50, 150, 40, 40);  // 3
      //delay(10);
     
      fill(255, 255, 0);
      for (grow = 40; grow < 90; grow += 2) {
        ellipse(50, 150, grow, grow);
      }
      //Snare.trigger();
      drumTrigger(4);
      break;
    default:

      break;
  }
}

void drumTrigger(int drum) {
  switch(drum) {
    case 1:
      BigDrum.trigger();
    break;
    case 2:
      Cowbell.trigger();
    break;
    case 3:
      Cymbals.trigger();
    break;
    case 4:
      Snare.trigger();
    break;
    default:
    break;
  }
}

void stop()
{
  // always close Minim audio classes when you are done with them
  kick.close();
  BigDrum.close();
  Cowbell.close();
  Cymbals.close();
  Snare.close();
  
  minim.stop();
  super.stop();
}
